{
Volume3D
3D function library for CAM purposes

program author
Arndt Kritzner, see http://www.kritzner.de

version
1.0.1 ... 2003-01-18 bugfix (cone facet orientation)
1.0 ... 2002-09-07

licenses:
volume3d is available under the terms of GNUs GPL (for developers of free software,
only FreePascal or GNU Pascal with Linux) or alternatively under a commercial
license (for developers of commercial software)

All rights reserved.
Any usage in another kind than described in the purchased license is prohibited.
If you want to choose the GNU GPL on another platform than GNU/Linux ask for a
free license for your preferred OS mailto:arndt@kritzner.de.

See http://www.kritzner.de/pages/v3d/v3d.html for technical and licensing details.
}

{
Unit form3d
shape generation functions for basic shapes (triangle, box, icosaeder, sphere, prism, cone, cylinder)
}

unit form3d;

interface

uses math,objects,triangle3d,shape3d;

function triangle(x1,y1,z1,x2,y2,z2,x3,y3,z3:float3d;name:string;max_:tri_idx3d):pshape_3d;
function triangle(p1,p2,p3:tpoint;name:string;max:tri_idx3d):pshape_3d;

function box(x1,y1,z1,x2,y2,z2:float3d;name:string;max_:tri_idx3d):pshape_3d;
function box(p1,p2:tpoint;name:string;max_:tri_idx3d):pshape_3d;

function prism(z1,z2:float3d;no_points:poly_idx3d;points:ppoly;name:string;max_:tri_idx3d):pshape_3d;

function icosaeder(r:float3d;name:string;max_:tri_idx3d):pshape_3d;

function triangle_sphere(s:pshape_3d;name:string):pshape_3d;
function sphere(r:float3d;name:string;max_:tri_idx3d):pshape_3d;

function cone(r1,r2,h:float3d;name:string;max_:tri_idx3d):pshape_3d;
function cylinder(r,h:float3d;name:string;max_:tri_idx3d):pshape_3d;

const facet_precision:float3d = pi/180*5;

implementation

function triangle(x1,y1,z1,x2,y2,z2,x3,y3,z3:float3d;name:string;max_:tri_idx3d):pshape_3d;
var t:ptriangle;
{$ifndef FKT_RESULT}		
		result:pshape_3d;
{$endif}
begin
	new(result,init(max_,name));
	
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=x1;t^.p1.y:=y1;t^.p1.z:=z1; t^.p2.x:=x2;t^.p2.y:=y2;t^.p2.z:=z2; t^.p3.x:=x3;t^.p3.y:=y3;t^.p3.z:=z3;
	result^.ins_triangle(t);
	
{$ifndef FKT_RESULT}		
	triangle:=result;
{$endif}
end;

function triangle(p1,p2,p3:tpoint;name:string;max_:tri_idx3d):pshape_3d;
begin
	triangle:=triangle(p1.x,p1.y,p1.z,p2.x,p2.y,p2.z,p3.x,p3.y,p3.z,name,max_);
end;

function box(x1,y1,z1,x2,y2,z2:float3d;name:string;max_:tri_idx3d):pshape_3d;
var t:ptriangle;
		p1,p2:tpoint;
{$ifndef FKT_RESULT}		
		result:pshape_3d;
{$endif}
begin
	if x2>x1 then begin
	  p1.x:=x1;p2.x:=x2;
	end else begin
	  p1.x:=x2;p2.x:=x1;
	end;
	if y2>y1 then begin
	  p1.y:=y1;p2.y:=y2;
	end else begin
	  p1.y:=y2;p2.y:=y1;
	end;
	if z2>z1 then begin
	  p1.z:=z1;p2.z:=z2;
	end else begin
	  p1.z:=z2;p2.z:=z1;
	end;
	new(result,init(max_,name));
	
{linke seitenflaeche}	
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=p1.x;t^.p1.y:=p1.y;t^.p1.z:=p1.z; t^.p2.x:=p1.x;t^.p2.y:=p1.y;t^.p2.z:=p2.z; t^.p3.x:=p1.x;t^.p3.y:=p2.y;t^.p3.z:=p1.z;
	result^.ins_triangle(t);
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=p1.x;t^.p1.y:=p2.y;t^.p1.z:=p2.z; t^.p2.x:=p1.x;t^.p2.y:=p2.y;t^.p2.z:=p1.z; t^.p3.x:=p1.x;t^.p3.y:=p1.y;t^.p3.z:=p2.z;
	result^.ins_triangle(t);
	
{Front}	
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=p1.x;t^.p1.y:=p1.y;t^.p1.z:=p1.z; t^.p2.x:=p2.x;t^.p2.y:=p1.y;t^.p2.z:=p1.z; t^.p3.x:=p1.x;t^.p3.y:=p1.y;t^.p3.z:=p2.z;
	result^.ins_triangle(t);
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=p1.x;t^.p1.y:=p1.y;t^.p1.z:=p2.z; t^.p2.x:=p2.x;t^.p2.y:=p1.y;t^.p2.z:=p1.z; t^.p3.x:=p2.x;t^.p3.y:=p1.y;t^.p3.z:=p2.z;
	result^.ins_triangle(t);
	
{Boden}	
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=p1.x;t^.p1.y:=p1.y;t^.p1.z:=p1.z; t^.p2.x:=p1.x;t^.p2.y:=p2.y;t^.p2.z:=p1.z; t^.p3.x:=p2.x;t^.p3.y:=p1.y;t^.p3.z:=p1.z;
	result^.ins_triangle(t);
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=p1.x;t^.p1.y:=p2.y;t^.p1.z:=p1.z; t^.p2.x:=p2.x;t^.p2.y:=p2.y;t^.p2.z:=p1.z; t^.p3.x:=p2.x;t^.p3.y:=p1.y;t^.p3.z:=p1.z;
	result^.ins_triangle(t);
	
{rechte Seitenflaeche}	
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=p2.x;t^.p1.y:=p1.y;t^.p1.z:=p1.z; t^.p2.x:=p2.x;t^.p2.y:=p2.y;t^.p2.z:=p1.z; t^.p3.x:=p2.x;t^.p3.y:=p1.y;t^.p3.z:=p2.z;
	result^.ins_triangle(t);
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=p2.x;t^.p1.y:=p2.y;t^.p1.z:=p2.z; t^.p2.x:=p2.x;t^.p2.y:=p1.y;t^.p2.z:=p2.z; t^.p3.x:=p2.x;t^.p3.y:=p2.y;t^.p3.z:=p1.z;
	result^.ins_triangle(t);
	
{Rckwand}	
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=p1.x;t^.p1.y:=p2.y;t^.p1.z:=p1.z; t^.p2.x:=p1.x;t^.p2.y:=p2.y;t^.p2.z:=p2.z; t^.p3.x:=p2.x;t^.p3.y:=p2.y;t^.p3.z:=p1.z;
	result^.ins_triangle(t);
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=p1.x;t^.p1.y:=p2.y;t^.p1.z:=p2.z; t^.p2.x:=p2.x;t^.p2.y:=p2.y;t^.p2.z:=p2.z; t^.p3.x:=p2.x;t^.p3.y:=p2.y;t^.p3.z:=p1.z;
	result^.ins_triangle(t);
	
{Deckflche}	
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=p1.x;t^.p1.y:=p1.y;t^.p1.z:=p2.z; t^.p2.x:=p2.x;t^.p2.y:=p1.y;t^.p2.z:=p2.z; t^.p3.x:=p1.x;t^.p3.y:=p2.y;t^.p3.z:=p2.z;
	result^.ins_triangle(t);
	new(t);
	t^.flag:=tf_init;
	t^.p1.x:=p1.x;t^.p1.y:=p2.y;t^.p1.z:=p2.z; t^.p2.x:=p2.x;t^.p2.y:=p1.y;t^.p2.z:=p2.z; t^.p3.x:=p2.x;t^.p3.y:=p2.y;t^.p3.z:=p2.z;
	result^.ins_triangle(t);
	
{$ifndef FKT_RESULT}		
	box:=result;
{$endif}
end;

function box(p1,p2:tpoint;name:string;max_:tri_idx3d):pshape_3d;
begin
	box:=box(p1.x,p1.y,p1.z,p2.x,p2.y,p2.z,name,max_);
end;

function prism(z1,z2:float3d;no_points:poly_idx3d;points:ppoly;name:string;max_:tri_idx3d):pshape_3d;
var s_temp:pshape_3d;
		x,y,z:array[1..2] of float3d;
		t:ptriangle;
		i:poly_idx3d;
		idx1,idx2:tri_idx3d;
		error,original,clockwise:boolean;
		tri_rel,akt_rel:ttrianglerelation;
		p_count:array[1..2] of poly_idx3d;
		poly:array[1..2] of ppoly;
{$ifndef FKT_RESULT}		
		result:pshape_3d;
{$endif}
begin
	result:=nil;
	if (no_points>2) and (same_point(points^[0],points^[no_points-1])) and (z1<>z2) then begin
  	error:=false;
  	original:=true;
  	x[1]:=points^[0].x; y[1]:=points^[0].y;
  	x[2]:=points^[0].x; y[2]:=points^[0].y;
  	z[1]:=min(z1,z2);
  	z[2]:=max(z1,z2);
  	for i:=2 to no_points do begin
  		x[1]:=min(x[1],points^[i-1].x);
  		x[2]:=max(x[2],points^[i-1].x);
  		y[1]:=min(y[1],points^[i-1].y);
  		y[2]:=max(y[2],points^[i-1].y);
  		if points^[i-1].z<>0 then
  			error:=true;
  	end;
  	if error then
   		writeln('Grundpolygon liegt nicht in x-y-Ebene');
  		
  	
  	if not error then begin
  		for i:=1 to no_points do
  			points^[i-1].z:=z[1];
  		
  		poly[1]:=create_poly(no_points,points);
  		p_count[1]:=no_points;
  		
  		original:=false;
  		new(result,init(max_,name));
	
{Boden}	
  		new(s_temp,init(max_,'temp'));
  		new(t);
			t^.flag:=tf_init;
  		t^.p1.x:=x[1];t^.p1.y:=y[1];t^.p1.z:=z[1]; t^.p2.x:=x[2];t^.p2.y:=y[2];t^.p2.z:=z[1]; t^.p3.x:=x[2];t^.p3.y:=y[1];t^.p3.z:=z[1];
  		s_temp^.ins_triangle(t);
  		new(t);
			t^.flag:=tf_init;
  		t^.p1.x:=x[1];t^.p1.y:=y[1];t^.p1.z:=z[1]; t^.p2.x:=x[1];t^.p2.y:=y[2];t^.p2.z:=z[1]; t^.p3.x:=x[2];t^.p3.y:=y[2];t^.p3.z:=z[1];
  		s_temp^.ins_triangle(t);
			if not split_triangles(s_temp,no_points,points) then begin
				error:=true;
     		writeln('Aufteilung der Bodenflche von '+s_temp^.name+' fehlgeschlagen');
			end;
		end;
		if not error then
			if not reduce_triangles(s_temp,no_points,points) then begin
  			error:=true;
     		writeln('Reduzierung der Bodenflche von '+s_temp^.name+' fehlgeschlagen');
  		end;
  	if not error then begin
  		for idx1:=1 to s_temp^.count do begin
	  		t:=s_temp^.get_triangle(idx1-1);
	  		insert_poly_point(p_count[1],poly[1],t^.p1);
	  		insert_poly_point(p_count[1],poly[1],t^.p2);
	  		insert_poly_point(p_count[1],poly[1],t^.p3);
	  	end;
  		if result^.include_triangles(s_temp) then
  			dispose(s_temp,done)
  		else begin
  			error:=true;
     		writeln('bernahme von '+s_temp^.name+' fehlgeschlagen');
  		end;
  	end;
	
{Deckflaeche}
		if not error then begin	
  		for i:=1 to no_points do
  			points^[i-1].z:=z[2];
  		
  		poly[2]:=create_poly(no_points,points);
  		p_count[2]:=no_points;
  		
  		new(s_temp,init(max_,'temp'));
  		new(t);
			t^.flag:=tf_init;
  		t^.p1.x:=x[1];t^.p1.y:=y[1];t^.p1.z:=z[2]; t^.p2.x:=x[2];t^.p2.y:=y[1];t^.p2.z:=z[2]; t^.p3.x:=x[2];t^.p3.y:=y[2];t^.p3.z:=z[2];
  		s_temp^.ins_triangle(t);
  		new(t);
			t^.flag:=tf_init;
  		t^.p1.x:=x[1];t^.p1.y:=y[1];t^.p1.z:=z[2]; t^.p2.x:=x[2];t^.p2.y:=y[2];t^.p2.z:=z[2]; t^.p3.x:=x[1];t^.p3.y:=y[2];t^.p3.z:=z[2];
  		s_temp^.ins_triangle(t);
			if not split_triangles(s_temp,no_points,points) then begin
				error:=true;
     		writeln('Aufteilung der Deckflche von '+s_temp^.name+' fehlgeschlagen');
			end;
		end;
		if not error then
			if not reduce_triangles(s_temp,no_points,points) then begin
  			error:=true;
     		writeln('Reduzierung der Deckflche von '+s_temp^.name+' fehlgeschlagen');
  		end;
  	if not error then begin
  		for idx1:=1 to s_temp^.count do begin
	  		t:=s_temp^.get_triangle(idx1-1);
	  		insert_poly_point(p_count[2],poly[2],t^.p1);
	  		insert_poly_point(p_count[2],poly[2],t^.p2);
	  		insert_poly_point(p_count[2],poly[2],t^.p3);
	  	end;
  		if result^.include_triangles(s_temp) then
  			dispose(s_temp,done)
  		else begin
  			error:=true;
     		writeln('bernahme von '+s_temp^.name+' fehlgeschlagen');
  		end;
  	end;
  	
  	if p_count[1]<>p_count[2] then
  	  error:=true;
  		
  	if not original then
  		for i:=1 to no_points do
  			points^[i-1].z:=0;
  			
{Seitenflaechen}
		if not error then begin
  		new(s_temp,init(max_,'temp'));
			for i:=1 to p_count[1]-1 do begin
    		new(t);
				t^.flag:=tf_init;
    		t^.p1.x:=poly[1]^[i-1].x;t^.p1.y:=poly[1]^[i-1].y;t^.p1.z:=z[1];
    		t^.p2.x:=poly[1]^[i].x;t^.p2.y:=poly[1]^[i].y;t^.p2.z:=z[1];
    		t^.p3.x:=poly[2]^[i].x;t^.p3.y:=poly[2]^[i].y;t^.p3.z:=z[2];
    		if not s_temp^.ins_triangle(t) then
    		  error:=true;
    		new(t);
				t^.flag:=tf_init;
    		t^.p1.x:=poly[1]^[i-1].x;t^.p1.y:=poly[1]^[i-1].y;t^.p1.z:=z[1];
    		t^.p2.x:=poly[2]^[i].x;t^.p2.y:=poly[2]^[i].y;t^.p2.z:=z[2];
    		t^.p3.x:=poly[2]^[i-1].x;t^.p3.y:=poly[2]^[i-1].y;t^.p3.z:=z[2];
    		if not s_temp^.ins_triangle(t) then
    			error:=true;
			end;
			if error then
				writeln('Erzeugen der Seitenflchen in '+s_temp^.name+' fehlgeschlagen')
			else begin
				clockwise:=false;
				for idx1:=0 to s_temp^.count-1 do begin
					tri_rel.r:=tt_none;
					for idx2:=0 to s_temp^.count-1 do
					  if idx1<>idx2 then begin
							akt_rel:=triangle_triangle(s_temp^.get_triangle(idx1),s_temp^.get_triangle(idx2));
							if akt_rel.r in [tt_back_2_surf,tt_back_2_back] then
								if tri_rel.r=tt_none then
									tri_rel:=akt_rel
								else
									if tri_rel.d>akt_rel.d then
										tri_rel:=akt_rel;
						end;
					if tri_rel.r in [tt_back_2_surf,tt_none] then
					  clockwise:=true;
				end;
				if clockwise then
				  inside2out(s_temp);
    		if result^.include_triangles(s_temp) then
    			dispose(s_temp,done)
    		else begin
    			error:=true;
       		writeln('bernahme von '+s_temp^.name+' (Seitenflchen) fehlgeschlagen');
    		end;
			end;
		end;
	end else
		writeln('Polygon nicht fuer Prisma geeignet');
{$ifndef FKT_RESULT}		
	prism:=result;
{$endif}
end;

function icosaeder(r:float3d;name:string;max_:tri_idx3d):pshape_3d;
var t:ptriangle;
		i:byte;
		side,h_5circle,r_5circle:float3d;
{$ifndef FKT_RESULT}		
		result:pshape_3d;
{$endif}
begin
	side:=2*cos(arcsin(0.5/sin(pi/5)));
	h_5circle:=sin(pi/2-2*arcsin(0.5*side));
	r_5circle:=sqrt(1-h_5circle*h_5circle);
	new(result,init(max_,name));
	for i:=0 to 4 do begin
		new(t);
		t^.flag:=tf_init;
 		t^.p1.x:=0;t^.p1.y:=0;t^.p1.z:=r;
 		t^.p2.x:=cos(2*pi/5*i)*r_5circle*r;t^.p2.y:=sin(2*pi/5*i)*r_5circle*r;t^.p2.z:=h_5circle*r;
 		t^.p3.x:=cos(2*pi/5*(i+1))*r_5circle*r;t^.p3.y:=sin(2*pi/5*(i+1))*r_5circle*r;t^.p3.z:=h_5circle*r;
 		result^.ins_triangle(t);
		new(t);
		t^.flag:=tf_init;
 		t^.p1.x:=cos(2*pi/5*(i+1))*r_5circle*r;t^.p1.y:=sin(2*pi/5*(i+1))*r_5circle*r;t^.p1.z:=h_5circle*r;
 		t^.p2.x:=cos(2*pi/5*i)*r_5circle*r;t^.p2.y:=sin(2*pi/5*i)*r_5circle*r;t^.p2.z:=h_5circle*r;
 		t^.p3.x:=cos(2*pi/5*(i+0.5))*r_5circle*r;t^.p3.y:=sin(2*pi/5*(i+0.5))*r_5circle*r;t^.p3.z:=-h_5circle*r;
 		result^.ins_triangle(t);
		new(t);
		t^.flag:=tf_init;
 		t^.p1.x:=cos(2*pi/5*i)*r_5circle*r;t^.p1.y:=sin(2*pi/5*i)*r_5circle*r;t^.p1.z:=h_5circle*r;
 		t^.p2.x:=cos(2*pi/5*(i-0.5))*r_5circle*r;t^.p2.y:=sin(2*pi/5*(i-0.5))*r_5circle*r;t^.p2.z:=-h_5circle*r;
 		t^.p3.x:=cos(2*pi/5*(i+0.5))*r_5circle*r;t^.p3.y:=sin(2*pi/5*(i+0.5))*r_5circle*r;t^.p3.z:=-h_5circle*r;
 		result^.ins_triangle(t);
		new(t);
		t^.flag:=tf_init;
 		t^.p1.x:=0;t^.p1.y:=0;t^.p1.z:=-r;
 		t^.p2.x:=cos(2*pi/5*(i+0.5))*r_5circle*r;t^.p2.y:=sin(2*pi/5*(i+0.5))*r_5circle*r;t^.p2.z:=-h_5circle*r;
 		t^.p3.x:=cos(2*pi/5*(i-0.5))*r_5circle*r;t^.p3.y:=sin(2*pi/5*(i-0.5))*r_5circle*r;t^.p3.z:=-h_5circle*r;
 		result^.ins_triangle(t);
	end;
{$ifndef FKT_RESULT}		
	icosaeder:=result;
{$endif}
end;

function triangle_4(t:ptriangle;name:string):pshape_3d;
{unterteilt vorhandenes Dreieck in 4 Dreiecke, alle Seiten werden halbiert}
var t_n:ptriangle;
{$ifndef FKT_RESULT}		
		result:pshape_3d;
{$endif}
begin
	new(result,init(4,name));
	new(t_n);
	t_n^.flag:=tf_init;
 	t_n^.p1:=t^.p1;
 	t_n^.p2:=vec_add(t^.p1,vec_scale(point_point(t^.p1,t^.p2),0.5));
 	t_n^.p3:=vec_add(t^.p1,vec_scale(point_point(t^.p1,t^.p3),0.5));
 	result^.ins_triangle(t_n);
	new(t_n);
	t_n^.flag:=tf_init;
 	t_n^.p1:=t^.p2;
 	t_n^.p2:=vec_add(t^.p2,vec_scale(point_point(t^.p2,t^.p3),0.5));
 	t_n^.p3:=vec_add(t^.p1,vec_scale(point_point(t^.p1,t^.p2),0.5));
 	result^.ins_triangle(t_n);
	new(t_n);
	t_n^.flag:=tf_init;
 	t_n^.p1:=t^.p3;
 	t_n^.p2:=vec_add(t^.p1,vec_scale(point_point(t^.p1,t^.p3),0.5));
 	t_n^.p3:=vec_add(t^.p2,vec_scale(point_point(t^.p2,t^.p3),0.5));
 	result^.ins_triangle(t_n);
	new(t_n);
	t_n^.flag:=tf_init;
 	t_n^.p1:=vec_add(t^.p1,vec_scale(point_point(t^.p1,t^.p2),0.5));
 	t_n^.p2:=vec_add(t^.p2,vec_scale(point_point(t^.p2,t^.p3),0.5));
 	t_n^.p3:=vec_add(t^.p1,vec_scale(point_point(t^.p1,t^.p3),0.5));
 	result^.ins_triangle(t_n);
{$ifndef FKT_RESULT}		
 	triangle_4:=result;
{$endif}
end;

procedure points_sphere(s:pshape_3d;r:float3d);
{projiziert alle Punkte auf eine Kugeloberflaeche mit vorgegebenem Radius um den Koordinatenursprung}
var t:ptriangle;
		idx:tri_idx3d;
begin
	if s^.count>0 then
  	for idx:=0 to s^.count-1 do begin
	  	t:=s^.get_triangle(idx);
	  	t^.p1:=vec_scale(t^.p1,r/vec_len(t^.p1));
	  	t^.p2:=vec_scale(t^.p2,r/vec_len(t^.p2));
	  	t^.p3:=vec_scale(t^.p3,r/vec_len(t^.p3));
	  end;
end;

function triangle_sphere(s:pshape_3d;name:string):pshape_3d;
{teilt ein Dreieck in Subdreiecke, die eine Kugeloberflche bilden}
var s_n,s_o,s_temp:pshape_3d;
		arc:float3d;
		r:float3d;
		t:ptriangle;
		idx:tri_idx3d;
{$ifndef FKT_RESULT}		
		result:pshape_3d;
{$endif}
begin
	result:=nil;
	s_n:=nil;
	s_o:=nil;
	if s^.count > 0 then begin
		t:=s^.get_triangle(0);
		r:=(vec_len(t^.p1)+vec_len(t^.p2)+vec_len(t^.p3))/3;
  	arc:=arccos(vec_p_vec(t^.p1,t^.p2)/vec_len(t^.p1)/vec_len(t^.p2));
  	while arc>facet_precision do begin
  		if assigned(s_n) then
  			s_o:=s_n
  		else
  			s_o:=s^.clone_shape('');
  		new(s_n,init(4*s_o^.count,''));
  		for idx:=0 to s_o^.count-1 do begin
  			t:=s_o^.get_triangle(idx);
  			s_temp:=triangle_4(t,'');
  			s_n^.include_triangles(s_temp);
  			dispose(s_temp,done);
  		end;
  		points_sphere(s_n,r);
  		if assigned(s_o) then
  			dispose(s_o,done);
  		t:=s_n^.get_triangle(0);
    	arc:=arccos(vec_p_vec(t^.p1,t^.p2)/vec_len(t^.p1)/vec_len(t^.p2));
  	end;
  	result:=s_n;
	end;
{$ifndef FKT_RESULT}		
	triangle_sphere:=result;
{$endif}
end;

function sphere(r:float3d;name:string;max_:tri_idx3d):pshape_3d;
{Kugel mit Radius r, unter Beruecksichtigung der vorgegebenen Przision}
var s_iso,s_tri:pshape_3d;
{$ifndef FKT_RESULT}		
		result:pshape_3d;
{$endif}
begin
	s_iso:=icosaeder(r,'temp_icosaeder',20);
	s_tri:=triangle_sphere(s_iso,'temp_sphere');
	dispose(s_iso,done);
	if s_tri^.count <= max_ then begin
		new(result,init(max_,name));
		result^.include_triangles(s_tri);
	end else begin
		result:=nil;
 		writeln('Nicht gengend Dreiecke (',max_,', bentigt:',s_tri^.count,') fr Kugel reserviert.');
	end;
	dispose(s_tri,done);
{$ifndef FKT_RESULT}		
	sphere:=result;
{$endif}
end;

function cone(r1,r2,h:float3d;name:string;max_:tri_idx3d):pshape_3d;
{Kegel mit Radius r1 (unten) und r2 (oben), Hhe h. Die vorgegebene Preisprzision wird eingehalten}
var i:tri_idx3d;
		t:ptriangle;
		facet:tri_idx3d;
		incr:float3d;
		error:boolean;
{$ifndef FKT_RESULT}		
		result:pshape_3d;
{$endif}
begin
	result:=nil;
	facet:=round(2*pi/facet_precision);
	if facet>2 then begin
		error:=false;
		new(result,init(max_,name));
  	incr:=2*pi/facet;
  	for i:=1 to facet do begin
			if not error then begin
    		if r1>0 then begin
{Mantelflche, Basis:unten}
        	new(t);
					t^.flag:=tf_init;
         	t^.p1:=point(r1*cos((i-1)*incr),r1*sin((i-1)*incr),0);
         	t^.p2:=point(r1*cos(i*incr),r1*sin(i*incr),0);
         	t^.p3:=point(r2*cos((i-0.5)*incr),r2*sin((i-0.5)*incr),h);
         	if not result^.ins_triangle(t) then
  					error:=true;
{Bodenflche}
        	new(t);
					t^.flag:=tf_init;
         	t^.p1:=point(r1*cos(i*incr),r1*sin(i*incr),0);
         	t^.p2:=point(r1*cos((i-1)*incr),r1*sin((i-1)*incr),0);
         	t^.p3:=point(0,0,0);
         	if not result^.ins_triangle(t) then
  					error:=true;
    		end;
    		if r2>0 then begin
{Mantelflche, Basis:oben}
        	new(t);
					t^.flag:=tf_init;
         	t^.p1:=point(r2*cos((i+0.5)*incr),r2*sin((i+0.5)*incr),h);
         	t^.p2:=point(r2*cos((i-0.5)*incr),r2*sin((i-0.5)*incr),h);
         	t^.p3:=point(r1*cos(i*incr),r1*sin(i*incr),0);
         	if not result^.ins_triangle(t) then
  					error:=true;
{Deckflche}
        	new(t);
					t^.flag:=tf_init;
         	t^.p1:=point(r2*cos((i-0.5)*incr),r2*sin((i-0.5)*incr),h);
         	t^.p2:=point(r2*cos((i+0.5)*incr),r2*sin((i+0.5)*incr),h);
         	t^.p3:=point(0,0,h);
         	if not result^.ins_triangle(t) then
  					error:=true;
    		end;
			end;
  	end;
		if error then begin
			dispose(result,done);
			result:=nil;
		end;
	end;
{$ifndef FKT_RESULT}		
	cone:=result;
{$endif}
end;

function cylinder(r,h:float3d;name:string;max_:tri_idx3d):pshape_3d;
{Zylinder mit radius r, Hoehe h}
begin
	cylinder:=cone(r,r,h,name,max_);
end;

end.

