{
Volume3D
3D function library for CAM purposes

program author
Arndt Kritzner, see http://www.kritzner.de

version
1.0.1 ... 2003-01-18
1.0 ... 2002-09-07

licenses:
volume3d is available under the terms of GNUs GPL (for developers of free software,
only FreePascal or GNU Pascal with Linux) or alternatively under a commercial
license (for developers of commercial software)

All rights reserved.
Any usage in another kind than described in the purchased license is prohibited.
If you want to choose the GNU GPL on another platform than GNU/Linux ask for a
free license for your preferred OS mailto:arndt@kritzner.de.

See http://www.kritzner.de/pages/v3d/v3d.html for technical and licensing details.
}

{
Unit shape3d
inter-shape operations (tesselation, boolean operators)

calculation of additional inter-shape edges
shape addition, shape subtraction, shape interference
}

unit shape3d;

interface

uses objects,triangle3d;

function shape_shape(s1,s2:pshape_3d):boolean;
function reduce_shape(s1,s2:pshape_3d;tri_dir:ttri_tri_rel;reduce:stri_tri_rel;mark:byte):boolean;
function reduce_shape(s1,s2:pshape_3d;tri_dir:ttri_tri_rel;reduce:stri_tri_rel):boolean;
function reduce_shape(s:pshape_3d):boolean;
procedure inside2out(s:pshape_3d);
procedure facet_orientation(s:pshape_3d);
function split_triangles(s:pshape_3d;p:tpoint;linesonly:boolean):boolean;
function split_triangles(s:pshape_3d;p:tpoint):boolean;
function split_triangles(s:pshape_3d;no_points:poly_idx3d;points:ppoly):boolean;
function split_triangles(s1,s2:pshape_3d):boolean;
function reduce_triangles(s:pshape_3d;no_points:poly_idx3d;points:ppoly):boolean;
function add_shape(s1,s2:pshape_3d):pshape_3d;
function sub_shape(s1,s2:pshape_3d):pshape_3d;
function inter_shape(s1,s2:pshape_3d):pshape_3d;

implementation

function shape_shape(s1,s2:pshape_3d):boolean;
{fuehrt einen Kantenbeschnitt beider Oberflaechen aus}
var i,j,k0,k1,k2,idx:tri_idx3d;
		t:array[1..2] of ptriangle;
		l:ttri_tri_line;
		spli1,spli2:tsplit_tri;
		sub_tri:array[1..2,1..5] of ptriangle;
		splitted:array[1..2] of boolean;
		error:boolean;
begin
	if (s1^.count>0) and (s2^.count>0) then begin
		error:=false;
		i:=0;
		while i<s1^.count do begin
{$ifdef LOG}
  		if TriLog then
  			writeln('Dreieck: (',s1^.name,' (1): ',i,'[',s1^.count,'])');
{$endif}
			splitted[1]:=false;
			t[1]:=s1^.get_triangle(i);
			j:=0;
			while j<s2^.count do begin
				splitted[2]:=false;
				t[2]:=s2^.get_triangle(j);
				l:=tri_tri_line(t[1],t[2]);
				if l.ok then begin
{$ifdef LOG}
  				if TriLog then begin		
  					writeln('Geschnitten: (1:',i,'[',s1^.count,']) (2:',j,'[',s2^.count,'])');
  					writeln('Dreieck (1) (',t[1]^.p1.x:10:2,t[1]^.p1.y:10:2,t[1]^.p1.z:10:2,') (',
  									t[1]^.p2.x:10:2,t[1]^.p2.y:10:2,t[1]^.p2.z:10:2,') (',
  									t[1]^.p3.x:10:2,t[1]^.p3.y:10:2,t[1]^.p3.z:10:2,')');
  					writeln('Dreieck (2) (',t[2]^.p1.x:10:2,t[2]^.p1.y:10:2,t[2]^.p1.z:10:2,') (',
  									t[2]^.p2.x:10:2,t[2]^.p2.y:10:2,t[2]^.p2.z:10:2,') (',
  									t[2]^.p3.x:10:2,t[2]^.p3.y:10:2,t[2]^.p3.z:10:2,')');
  					writeln('Kante: (',l.p1.x:10:2,l.p1.y:10:2,l.p1.z:10:2,') (',l.p2.x:10:2,l.p2.y:10:2,l.p2.z:10:2,')');
  				end;
{$endif}
        	for k1:=1 to 2 do
        	  for k2:=1 to 5 do
        	    sub_tri[k1,k2]:=NIL;
					for k0:=1 to 2 do begin
  					idx:=0;
  					spli1:=split_tri(t[k0],l.p1);
  					if spli1.ok then begin
  					  for k1:=1 to 3 do
  					  	if assigned(spli1.t[k1]) then begin
  					  		spli2:=split_tri(spli1.t[k1],l.p2);
  					  		if spli2.ok then begin
  					  			for k2:=1 to 3 do
  					  				if assigned(spli2.t[k2]) then begin
  					  					inc(idx);
  					  					sub_tri[k0,idx]:=spli2.t[k2];
  					  				end;
    					  	end else begin
    					  		inc(idx);
    					  		sub_tri[k0,idx]:=spli1.t[k1];
    					  	end;
  					  	end;
  					end else begin
{$ifdef LOG}
							if TriLog then
	  						writeln('Teilung mit 1. Punkt fehlgeschlagen (',k0,')');
{$endif}
	  					spli2:=split_tri(t[k0],l.p2);
 				  		if spli2.ok then begin
 				  			for k2:=1 to 3 do
 				  				if assigned(spli2.t[k2]) then begin
 				  					inc(idx);
 				  					sub_tri[k0,idx]:=spli2.t[k2];
 				  				end;
{$ifdef LOG}
  							if TriLog then
  	  						writeln('Teilung mit 2. Punkt erfolgreich (',k0,')');
{$endif}
 				  		end;
  					end;
					end;
					for k0:=1 to 5 do begin
						if assigned(sub_tri[1,k0]) then begin
							if not s1^.ins_triangle(sub_tri[1,k0]) then error:=true;
							splitted[1]:=true;
{$ifdef LOG}
  						if TriLog then
      					writeln('Subdreieck (1[',s1^.count,']): (',sub_tri[1,k0]^.p1.x:10:2,sub_tri[1,k0]^.p1.y:10:2,sub_tri[1,k0]^.p1.z:10:2,') (',
      									sub_tri[1,k0]^.p2.x:10:2,sub_tri[1,k0]^.p2.y:10:2,sub_tri[1,k0]^.p2.z:10:2,') (',
      									sub_tri[1,k0]^.p3.x:10:2,sub_tri[1,k0]^.p3.y:10:2,sub_tri[1,k0]^.p3.z:10:2,')');
{$endif}
							sub_tri[1,k0]:=NIL;
						end;
						if assigned(sub_tri[2,k0]) then begin
							if not s2^.ins_triangle(sub_tri[2,k0]) then error:=true;
							splitted[2]:=true;
{$ifdef LOG}
  						if TriLog then
      					writeln('Subdreieck (2[',s2^.count,']): (',sub_tri[2,k0]^.p1.x:10:2,sub_tri[2,k0]^.p1.y:10:2,sub_tri[2,k0]^.p1.z:10:2,') (',
      									sub_tri[2,k0]^.p2.x:10:2,sub_tri[2,k0]^.p2.y:10:2,sub_tri[2,k0]^.p2.z:10:2,') (',
      									sub_tri[2,k0]^.p3.x:10:2,sub_tri[2,k0]^.p3.y:10:2,sub_tri[2,k0]^.p3.z:10:2,')');
{$endif}
							sub_tri[2,k0]:=NIL;
						end;
					end;
					if splitted[1] then begin
						s1^.del_triangle(i);
{$ifdef LOG}
  					if TriLog then begin
     					writeln('Originaldreieck (1) geloescht - Index: ',i);
   						s1^.list_triangles;
   					end;
{$endif}
					end;
					if splitted[2] then begin
						s2^.del_triangle(j);
{$ifdef LOG}
					if TriLog then begin
   					writeln('Originaldreieck (2) geloescht - Index: ',j);
   					s2^.list_triangles;
   				end;
{$endif}
					end;
{$ifdef LOG}
				end else begin
					if TriLog then
 						writeln('Nicht geschnitten (',i,'/',j,')');
{$endif}
				end;
				if splitted[1] or splitted[2] then
					j:=s2^.count
				else
					inc(j);
			end;
			if not (splitted[1] or splitted[2]) then
				inc(i);
		end;
		if not error then
		  error:=not split_triangles(s1,s2);
		if not error then
		  error:=not split_triangles(s2,s1);
		shape_shape:=not error;
	end else
	  shape_shape:=false;
end;

function reduce_shape(s1,s2:pshape_3d;tri_dir:ttri_tri_rel;reduce:stri_tri_rel;mark:byte):boolean;
var tt_aware:stri_tri_rel;
		rel,akt:ttrianglerelation;
		i,j:tri_idx3d;
{$ifdef LOG}
		t:ptriangle;
{$endif}
begin
{$ifdef LOG}
	if TriLog then
		writeln('Reduce Shape -- Objekt 1 (wird reduziert):',s1^.Name,', Objekt 2:',s2^.Name);
{$endif}
	if (s1^.count>0) then begin
  	case tri_dir of
  		tt_all:tt_aware:=[tt_back_2_back,tt_back_2_surf,tt_surf_2_back,tt_surf_2_surf];
  		tt_surf:tt_aware:=[tt_surf_2_back,tt_surf_2_surf];
  		tt_surf_pane:tt_aware:=[tt_surf_2_back,tt_surf_2_surf,tt_pane_double,tt_pane_anti];
  		tt_back:tt_aware:=[tt_back_2_back,tt_back_2_surf];
  		tt_back_pane:tt_aware:=[tt_back_2_back,tt_back_2_surf,tt_pane_double,tt_pane_anti];
  		tt_pane:tt_aware:=[tt_pane_double,tt_pane_anti];
  	end;
  	i:=0;
		while i<s1^.count do begin
			rel.r:=tt_none;
			j:=0;
			while j<s2^.count do begin
				akt:=triangle_triangle(s1^.get_triangle(i),s2^.get_triangle(j));
				if akt.r in tt_aware then begin
{$ifdef LOG}
  				if TriLog then begin		
       			t:=s2^.get_triangle(j);
       			write('Dreieck: ',j,' (2) (',t^.p1.x:10:4,t^.p1.y:10:4,t^.p1.z:10:4,
       				') (',t^.p2.x:10:4,t^.p2.y:10:4,t^.p2.z:10:4,
       				') (',t^.p3.x:10:4,t^.p3.y:10:4,t^.p3.z:10:4,'): ');
       			case akt.r of
       				tt_none:writeln('keine');
       				tt_back_2_back:write('Rcken an Rcken');
       				tt_back_2_surf:write('Rcken an Oberflche');
       				tt_surf_2_back:write('Oberflche an Rcken');
       				tt_surf_2_surf:write('Oberflche an Oberflche');
       				tt_pane_double:write('doppelt');
       				tt_pane_anti:write('entgegengesetzt');
       			end;
       			if akt.r in reduce then
       				writeln(' Abstand ',akt.d:10:4,' wrde gelscht')
       			else
       			  writeln;
       		end;
{$endif}
					if (rel.r=tt_none) then
					  rel:=akt
					else
					  if (abs(rel.d)>abs(akt.d)) then
					    rel:=akt;
				end;
			  inc(j);
			end;
{$ifdef LOG}
  		if TriLog then begin		
  			t:=s1^.get_triangle(i);
  			write('Dreiecksbeziehung: ',i,' (',t^.p1.x:10:4,t^.p1.y:10:4,t^.p1.z:10:4,
  				') (',t^.p2.x:10:4,t^.p2.y:10:4,t^.p2.z:10:4,
  				') (',t^.p3.x:10:4,t^.p3.y:10:4,t^.p3.z:10:4,'): ');
  			case rel.r of
  				tt_none:write('keine');
  				tt_back_2_back:write('Rcken an Rcken');
  				tt_back_2_surf:write('Rcken an Oberflche');
  				tt_surf_2_back:write('Oberflche an Rcken');
  				tt_surf_2_surf:write('Oberflche an Oberflche');
   				tt_pane_double:write('doppelt');
   				tt_pane_anti:write('entgegengesetzt');
  			end;
  			if rel.r in reduce then
  				writeln(' wird gelscht (Flche:',tri_area(t):12:4,')')
  			else
  				writeln;
  		end;
{$endif}
			if rel.r in reduce then
				if mark=tf_init then
			  	s1^.del_triangle(i)
			  else begin
			  	s1^.get_triangle(i)^.flag:=(s1^.get_triangle(i)^.flag or mark);
				  inc(i);
			  end
			else
			  inc(i);
		end;
		reduce_shape:=true;
	end else
	  reduce_shape:=false;
end;

function reduce_shape(s1,s2:pshape_3d;tri_dir:ttri_tri_rel;reduce:stri_tri_rel):boolean;
begin
	reduce_shape:=reduce_shape(s1,s2,tri_dir,reduce,tf_init);
end;

function reduce_shape(s:pshape_3d):boolean;
var i:tri_idx3d;
begin
	if (s^.count>0) then begin
  	i:=0;
		while i<s^.count do
	  	if (s^.get_triangle(i)^.flag and tf_delete)=tf_delete then
		  	s^.del_triangle(i)
		  else
		  	inc(i);
		reduce_shape:=true;
	end else
		reduce_shape:=false;
end;

procedure inside2out(s:pshape_3d);
begin
	s^.inside2out;
end;

procedure facet_orientation(s:pshape_3d);
{vergibt die Facettenorientierung neu}
var idx,idx_,unknown,last_unknown:tri_idx3d;
		pi_1,pi_2:byte;
		p1,p2:tpoint;
		same:array[1..3] of byte;
		common:byte;
		mark:boolean;
    t,t_:ptriangle;
begin
{
Facetten, deren Rckseite nicht von anderen Facetten ueberdeckt wird, werden markiert.
Anschliessend wird die Orientierung umgekehrt
}
  if s^.count>0 then begin
    reduce_shape(s,s,tt_back,[tt_none],tf_mark);
    s^.inside2out(tf_mark);
{Facetten, deren Oberflche nicht von anderen Facetten ueberdeckt wird, werden markiert}
    reduce_shape(s,s,tt_surf,[tt_none],tf_mark);
    last_unknown:=0;
    repeat
      idx:=0;
      unknown:=0;
      while idx<s^.count do begin
        t:=s^.get_triangle(idx);
        idx_:=0;
        while (idx_<s^.count) and ((t^.flag and tf_mark)<>tf_mark) do begin
          t_:=s^.get_triangle(idx_);
          if (t_^.flag and tf_mark)=tf_mark then begin
            common:=0;
  					for pi_1:=1 to 3 do begin
  					  same[pi_1]:=0;
  					  case pi_1 of
  					    1:p1:=t^.p1;
  					    2:p1:=t^.p2;
  					    3:p1:=t^.p3;
  					  end;
  					  for pi_2:=1 to 3 do
  					    if same[pi_1]=0 then begin
       					  case pi_2 of
       					    1:p2:=t_^.p1;
       					    2:p2:=t_^.p2;
       					    3:p2:=t_^.p3;
       					  end;
    					    if same_point(p1,p2) then begin
    					      same[pi_1]:=pi_2;
    					      inc(common);
    					    end;
    					  end;
  					end;
  					if common=2 then begin
  					  if same[1]=0 then pi_1:=1;
  					  if same[2]=0 then pi_1:=2;
  					  if same[3]=0 then pi_1:=3;
  					  case pi_1 of
  					    1:mark:=((same[2]-same[3]=1) or (same[3]-same[2]=2));
  					    2:mark:=((same[3]-same[1]=1) or (same[1]-same[3]=2));
  					    3:mark:=((same[1]-same[2]=1) or (same[2]-same[1]=2));
  					  end;
  					  if not mark then
  					    inside_out(t);
  					  t^.flag:=(t^.flag or tf_mark);
  					end;
					end;	
          inc(idx_);
        end;
        inc(idx);
      end;
    until unknown=last_unknown;
	end;
end;

function split_triangles(s:pshape_3d;p:tpoint;linesonly:boolean):boolean;
{teilt alle betroffenen Dreiecke der Liste am Punkt}
var i,k,idx:tri_idx3d;
		t:ptriangle;
		spli:tsplit_tri;
		sub_tri:array[1..3] of ptriangle;
		splitted:boolean;
		error:boolean;
begin
	if s^.count>0 then begin
		error:=false;
		i:=0;
		while i<s^.count do begin
			splitted:=false;
			t:=s^.get_triangle(i);
  	  for k:=1 to 3 do
  	    sub_tri[k]:=NIL;
  		idx:=0;
  		spli:=split_tri(t,p,linesonly);
  		if spli.ok then begin
  		  for k:=1 to 3 do
  		  	if assigned(spli.t[k]) then begin
    				inc(idx);
    				sub_tri[idx]:=spli.t[k];
  				end;
  		end;
			for k:=1 to 3 do begin
				if assigned(sub_tri[k]) then begin
					if not s^.ins_triangle(sub_tri[k]) then error:=true;
					splitted:=true;
{$ifdef LOG}
  				if TriLog then
      			writeln('Subdreieck [',s^.count,']: (',sub_tri[k]^.p1.x:10:2,sub_tri[k]^.p1.y:10:2,sub_tri[k]^.p1.z:10:2,') (',
      							sub_tri[k]^.p2.x:10:2,sub_tri[k]^.p2.y:10:2,sub_tri[k]^.p2.z:10:2,') (',
      							sub_tri[k]^.p3.x:10:2,sub_tri[k]^.p3.y:10:2,sub_tri[k]^.p3.z:10:2,')');
{$endif}
					sub_tri[k]:=NIL;
				end;
			end;
			if splitted then begin
				s^.del_triangle(i);
{$ifdef LOG}
  			if TriLog then
     			writeln('Originaldreieck geloescht');
{$endif}
			end;
			if not splitted then
				inc(i);
		end;
		split_triangles:=not error;
	end else
	  split_triangles:=false;
end;

function split_triangles(s:pshape_3d;p:tpoint):boolean;
begin
  split_triangles:=split_triangles(s,p,false);
end;

function split_triangles(s:pshape_3d;no_points:poly_idx3d;points:ppoly):boolean;
{teilt alle betroffenen Dreiecke der Liste entlang des vorgegebenen Polygons}
var p_idx:poly_idx3d;
		i,k,idx,idx2,count_tri:tri_idx3d;
		t:ptriangle;
		l:tline;
		tl:ttri_tri_line;
		spli:tsplit_tri;
		sub_tri:array[1..5] of ptriangle;
		splitted:boolean;
		error:boolean;
{$ifndef FKT_RESULT}		
		result:boolean;
{$endif}
begin
	result:=true;
	for p_idx:=2 to no_points do begin
  	if s^.count>0 then begin
  		error:=false;
  		i:=0;
  		while i<s^.count do begin
  			splitted:=false;
  			t:=s^.get_triangle(i);
  			l.p1:=points^[p_idx-2];
  			l.p2:=points^[p_idx-1];
  			tl:=line_tri_line(@l,t);
  			if tl.ok then begin
  			  count_tri:=0;
      	  for k:=1 to 5 do
      	    sub_tri[k]:=NIL;
      		idx:=0;
      		spli:=split_tri(t,tl.p1);
      		if spli.ok then begin
      		  for k:=1 to 3 do
      		  	if assigned(spli.t[k]) then begin
        				inc(idx);
        				sub_tri[idx]:=spli.t[k];
      				end;
        		count_tri:=idx;
        		k:=1;
        		while k<=idx do begin
        			spli:=split_tri(sub_tri[k],tl.p2);
        			if spli.ok then begin
        			  for idx2:=succ(k) to idx do
        			    sub_tri[idx2-1]:=sub_tri[idx2];
        			  dec(idx);
        			  dec(count_tri);
        			  for idx2:=1 to 3 do
        			    if assigned(spli.t[idx2]) then begin
        			    	inc(count_tri);
        			    	sub_tri[count_tri]:=spli.t[idx2];
        			    end;
        			end else
        			  inc(k);
        		end;
      		end else begin
        		spli:=split_tri(t,tl.p2);
        		if spli.ok then begin
        		  for k:=1 to 3 do
        		  	if assigned(spli.t[k]) then begin
          				inc(idx);
          				sub_tri[idx]:=spli.t[k];
        				end;
          		count_tri:=idx;
          	end;
      		end;
      		if count_tri>0 then
      			for k:=1 to count_tri do begin
    					if not s^.ins_triangle(sub_tri[k]) then error:=true;
    					splitted:=true;
{$ifdef LOG}
  						if TriLog then
          			writeln('Subdreieck [',s^.count,']: (',sub_tri[k]^.p1.x:10:2,sub_tri[k]^.p1.y:10:2,sub_tri[k]^.p1.z:10:2,') (',
          							sub_tri[k]^.p2.x:10:2,sub_tri[k]^.p2.y:10:2,sub_tri[k]^.p2.z:10:2,') (',
          							sub_tri[k]^.p3.x:10:2,sub_tri[k]^.p3.y:10:2,sub_tri[k]^.p3.z:10:2,')');
{$endif}
    					sub_tri[k]:=NIL;
      			end;
    			if splitted then begin
    				s^.del_triangle(i);
{$ifdef LOG}
					if TriLog then
       			writeln('Originaldreieck geloescht');
{$endif}
    			end;
    			if not splitted then
    				inc(i);
  			end else
  			  inc(i);
  		end;
  		if error then
  			result:=false;
  	end else
  	  result:=false;
	end;
{$ifndef FKT_RESULT}		
	split_triangles:=result;
{$endif}
end;

function split_triangles(s1,s2:pshape_3d):boolean;
{teilt alle jeweils betroffenen Dreiecke der Liste s2 an allen Punkten der Dreiecke der Liste s1}
var i:tri_idx3d;
		t:ptriangle;
{$ifndef FKT_RESULT}		
		result:boolean;
{$endif}
begin
  result:=true;
	i:=0;
	while (i<s1^.count) and result do begin
		t:=s1^.get_triangle(i);
		if result then
  		if not split_triangles(s2,t^.p1,true) then
	  	  result:=false;
		if result then
  		if not split_triangles(s2,t^.p2,true) then
	  	  result:=false;
		if result then
  		if not split_triangles(s2,t^.p3,true) then
	  	  result:=false;
		inc(i);
	end;
{$ifndef FKT_RESULT}		
	split_triangles:=result;
{$endif}
end;

function reduce_triangles(s:pshape_3d;no_points:poly_idx3d;points:ppoly):boolean;
var i:poly_idx3d;
		idx:tri_idx3d;
{$ifndef FKT_RESULT}		
		result:boolean;
{$endif}
begin
	result:=false;
	if s^.count>0 then begin
		for i:=1 to no_points do begin
			idx:=0;
			while idx<s^.count do
				if not point_in_poly(tri_norm(s^.get_triangle(idx)).p1,no_points,points) then
					s^.del_triangle(idx)
				else
					inc(idx);
		end;
		result:=true;
	end;
{$ifndef FKT_RESULT}		
	reduce_triangles:=result;
{$endif}
end;

function add_shape(s1,s2:pshape_3d):pshape_3d;
{$ifndef FKT_RESULT}		
var result:pshape_3d;
{$endif}
begin
  result:=nil;
  if shape_shape(s1,s2) then begin
  	if reduce_shape(s1,s2,tt_surf,[tt_surf_2_back]) then begin
    	if reduce_shape(s2,s1,tt_surf,[tt_surf_2_back]) then begin
      	if reduce_shape(s1,s2,tt_pane,[tt_pane_double,tt_pane_anti],tf_delete) then begin
      		if reduce_shape(s2,s1,tt_pane,[tt_pane_anti]) then begin
      		  reduce_shape(s1);
          	new(result,init(3*(s1^.count+s2^.count),s1^.name+'+'+s2^.name));
          	if not result^.include_triangles(s1) then
          		writeln('bernahme von '+s1^.name+' fehlgeschlagen');
          	if not result^.include_triangles(s2) then
          		writeln('bernahme von '+s2^.name+' fehlgeschlagen');
          end else
           	writeln('Fehler beim Reduzieren von ',s2^.name,' (doppelt liegende Bereiche)');
        end else
         	writeln('Fehler beim Reduzieren von ',s1^.name,' (doppelt liegende Bereiche)');
    	end else
      	writeln('Fehler beim Reduzieren von ',s1^.name);
  	end else
    	writeln('Fehler beim Reduzieren von ',s2^.name);
  end else
  	writeln('Fehler beim Verschneiden der Formen (Wahrscheinlich zu wenig Platz fr Facetten reserviert)');
  if assigned(result) then begin
    dispose(s2,done);
    dispose(s1,done);
  end;
{$ifndef FKT_RESULT}		
  add_shape:=result;
{$endif}
end;

function sub_shape(s1,s2:pshape_3d):pshape_3d;
{$ifndef FKT_RESULT}		
var result:pshape_3d;
{$endif}
begin
  result:=nil;
  if shape_shape(s1,s2) then begin
{$ifdef Log}
		if TriLog then begin		
  		writeln('sub_shape (nach shape_shape)');
  		s1^.list_triangles;
  		s2^.list_triangles;
		end;
{$endif}
  	if reduce_shape(s2,s1,tt_surf,[tt_surf_2_surf,tt_none],tf_delete) then begin
	  	if reduce_shape(s1,s2,tt_surf,[tt_surf_2_back],tf_delete) then begin
	  		if reduce_shape(s1,s2,tt_pane,[tt_pane_double,tt_pane_anti],tf_delete) then begin
	  			if reduce_shape(s2,s1,tt_pane,[tt_pane_double,tt_pane_anti],tf_delete) then begin
			  		reduce_shape(s2);
			  		reduce_shape(s1);
    		    inside2out(s2);
          	new(result,init(3*(s1^.count+s2^.count),s1^.name+'-'+s2^.name));
          	if not result^.include_triangles(s1) then
          		writeln('bernahme von '+s1^.name+' fehlgeschlagen');
          	if not result^.include_triangles(s2) then
          		writeln('bernahme von '+s2^.name+' fehlgeschlagen');
			  	end else
			     	writeln('Fehler beim Reduzieren von ',s2^.name,' (doppelt liegende Bereiche)')
			  end else
		     	writeln('Fehler beim Reduzieren von ',s1^.name,' (doppelt liegende Bereiche)');
	  	end else
      	writeln('Fehler beim Reduzieren von ',s1^.name);
  	end else
    	writeln('Fehler beim Reduzieren von ',s2^.name)
  end else
  	writeln('Fehler beim Verschneiden der Formen (Wahrscheinlich zu wenig Platz fr Facetten reserviert)');
  if assigned(result) then begin
    dispose(s1,done);
    dispose(s2,done);
  end;
{$ifndef FKT_RESULT}		
  sub_shape:=result;
{$endif}
end;

function inter_shape(s1,s2:pshape_3d):pshape_3d;
{$ifndef FKT_RESULT}		
var result:pshape_3d;
{$endif}
begin
  result:=nil;
  if shape_shape(s1,s2) then begin
  	if reduce_shape(s1,s2,tt_surf_pane,[tt_surf_2_surf,tt_none],tf_delete) then begin
	  	if reduce_shape(s2,s1,tt_surf_pane,[tt_surf_2_surf,tt_none],tf_delete) then begin
      	if reduce_shape(s1,s2,tt_pane,[tt_pane_double,tt_pane_anti],tf_delete) then begin
      		if reduce_shape(s2,s1,tt_pane,[tt_pane_anti],tf_delete) then begin
			  		reduce_shape(s1);
      		  reduce_shape(s2);
          	new(result,init(3*(s1^.count+s2^.count),s1^.name+' inter '+s2^.name));
          	if not result^.include_triangles(s1) then
          		writeln('bernahme von '+s1^.name+' fehlgeschlagen');
          	if not result^.include_triangles(s2) then
          		writeln('bernahme von '+s2^.name+' fehlgeschlagen');
			  	end else
			     	writeln('Fehler beim Reduzieren von ',s2^.name,' (doppelt liegende Bereiche)')
			  end else
		     	writeln('Fehler beim Reduzieren von ',s1^.name,' (doppelt liegende Bereiche)');
	  	end else
      	writeln('Fehler beim Reduzieren von ',s1^.name);
  	end else
    	writeln('Fehler beim Reduzieren von ',s2^.name)
  end else
  	writeln('Fehler beim Verschneiden der Formen (Wahrscheinlich zu wenig Platz fr Facetten reserviert)');
  if assigned(result) then begin
    dispose(s1,done);
    s1:=nil;
    dispose(s2,done);
    s2:=nil;
  end;
{$ifndef FKT_RESULT}		
  inter_shape:=result;
{$endif}
end;

end.
